unit uTerimaSMS;

interface

procedure CekSMS();

Type
        ConStateType = (Normal, TesKoneksiHP, SendSMS, ReadSMS, ReadInfo);

const sOK = #13#10'OK';
      sERROR = #13#10'ERROR';

      arSumber: array[0..2] of String[2] = ('SM', 'ME', 'MT');
      arJenisSMS: array[0..3] of String[9] = ('Baru', 'Inbox', 'Draft', 'Terkirim');

var
    Konek: Boolean;
    ConState: ConStateType;
    Buffer: WideString;
    ReadyState: Boolean;
    BatasStr: String;

implementation

uses Unit1, SysUtils, ComCtrls, Dialogs;

function PDU2Text(pdudata: string): string;
var
        pdu,isi,hasilteks,huruf: string;
        awal,
        i: integer;
        m,n,vgeser,sisa,
        c,d,e,f,panjang: byte;
        hasil,dbiner: array[1..9000] of byte;
begin
        if length(pdudata)=0 then begin
                Result := '';
                exit;
        end;
        pdu := copy(pdudata,3,length(pdudata));
        isi:= '';
        panjang := length(pdu) div 2;
        for i := 1 to panjang do begin
                huruf := copy(pdu, i*2 - 1, 2);
                dbiner[i] := StrToInt('$' + huruf);
        end;
        m := 1;
        vgeser := 0;
        sisa := 0;
        n := 1;
        while n <= panjang do begin
                c := dbiner[n];
                d := c shl vgeser;
                e := d or sisa;
                f := e and $7F;
                hasil[m] := f;
                Inc(vgeser);
                c := dbiner[n];
                d := c shr (8-vgeser);
                sisa := d;
                inc(m);
                inc(n);
                if vgeser >= 7 then begin
                        hasil[m] := sisa and $7F;
                        inc(m);
                        sisa := 0;
                        vgeser := 0;
                end;
        end;
        hasilteks := '';
        if hasil[1] = 5 then
                awal := 8
        else
        if hasil[1] = 9 then
                awal := 14
        else
        if hasil[1] = 11 then
                awal := 15
        else
                awal := 1;
        for i := awal to m - 1 do
                hasilteks := hasilteks + chr(hasil[i]);
        Result := hasilteks;
end;

procedure ConvertMSG(var datasms,smsc,tipe,pengirim,bentuk,
                        skema,tanggal,batas,isi: string);
var pdu: string;
    p,i: integer;
begin
        pdu := datasms;
        smsc := '';
        p := StrToInt('$' + copy(pdu, 1, 2)) - 1;
        pdu := copy(pdu,5,length(pdu)-4);
        for i := 1 to p do begin
                smsc := smsc + pdu[i*2];
                smsc := smsc + pdu[i*2-1];
        end;
        if smsc[length(smsc)] = 'F' then
                smsc := copy(smsc, 1, length(smsc) - 1);
        pdu := copy(pdu, p*2+1,length(pdu)-p*2);

        tipe := copy(pdu, 1, 2);
        if tipe = '06' then begin
                isi := '-delivery report-';
                pdu := copy(pdu, 5, length(pdu)-2);
        end
        else
        if tipe = 'F1' then
                pdu := copy(pdu, 5, length(pdu)-2)
        else
                pdu := copy(pdu, 3, length(pdu)-2);

        pengirim := '';
        p := StrToInt('$'+copy(pdu,1,2));
        if p mod 2 = 1 then inc(p);
        pdu := copy(pdu,5,length(pdu)-4);
        for i := 1 to p div 2 do begin
                pengirim := pengirim + pdu[i*2];
                pengirim := pengirim + pdu[i*2-1];
        end;
        if pengirim[length(pengirim)] = 'F' then
                pengirim := copy(pengirim, 1, length(pengirim) - 1);

        pdu := copy(pdu,p+1,length(pdu)-p);

        if (tipe <> '06') then begin
                bentuk := copy(pdu,1,2);
                pdu := copy(pdu, 3, length(pdu)-2);

                skema := copy(pdu,1,2);
                pdu := copy(pdu, 3, length(pdu)-2);
        end;

        if (tipe <> 'F1') then begin
        tanggal := pdu[6]+pdu[5] + '-' + pdu[4]+pdu[3] + '-' +
                   pdu[2]+pdu[1] + ' ' +
                   pdu[8]+pdu[7] + ':' + pdu[10]+pdu[9] + ':' +
                   pdu[12]+pdu[11];
        pdu := copy(pdu, 13, length(pdu)-12);
        end;
        
        batas := copy(pdu,1,2);
        pdu := copy(pdu, 3, length(pdu)-2);

        if (tipe <> '06') then isi := PDU2Text(pdu);
end;

procedure CekSMS;
var 
    smsc, tipe, pengirim, bentuk, skema, tanggal, batas,  
    isi,
    nomer,
    s : string;
    i,j : integer;
    l: TListItem;
begin
        if not Konek then exit;

        s := fUtama.sendGetData('AT+CPMS=' + arSumber[fUtama.cbSumber.ItemIndex] +#13, sOK);
        if Pos(sOK, s) = 0 then begin
                ShowMessage('Tidak dapat memilih media ' + fUtama.cbSumber.Text);
                exit;
        end;
        List.Clear;
        for j := 3 downto 0 do begin
              List.Text := fUtama.SendGetData('AT+CMGL=' + IntToStr(j) +#13, sOK);
              i := 0;
              while i < List.Count do begin
                    s := List.Strings[i];
                    if copy(s, 1, 7) = '+CMGL: ' then begin
                       nomer := copy(s, 8, pos(',', s) - 8);
                       inc(i);
                       s := List.Strings[i];
                       ConvertMSG(s, smsc, tipe, pengirim, bentuk, skema, tanggal, batas, isi);

                       l := fUtama.ListSMS.Items.Add;
                       l.Caption := pengirim;
                       l.SubItems.Add(tanggal);
                       l.SubItems.Add(isi);
                       l.SubItems.Add('Phone');
                       l.SubItems.Add(arJenisSMS[j]);
                       l.SubItems.Add(nomer);
                       l.SubItems.Add(fUtama.getIndex);
                    end;
                    inc(i);
              end;
        end;
end;

begin
        Konek := False;
        Buffer := '';
end.